<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, ref, inject } from 'vue';
import Post from '@/components/pdf/Post.vue';
import { useRoute } from 'vue-router';
import { request } from '@/lib/request';

const route = useRoute();
const layout:string = String(route.query.layout?route.query.layout:'portrait'); //portrait or landscape
const size:string = String(route.query.size?route.query.size:'A4'); //A0 ... A4
const comments:boolean = Boolean(route.query.comments?route.query.comments==="true":false); //show comments
const likes:boolean = Boolean(route.query.likes?route.query.likes:false); //show likes
const pageOpts = {layout, size, comments, likes};
const id = route.params.id;
const data = ref();
const configuration = inject<any>('configuration');
const basePath = configuration.basePath;
const headline = ref('');
const subheadline = ref('');
const url = ref('');
const adminMail = ref('');

const getBoardData = async()=>{
    let result = await request('GET', `${configuration.exportApiServer}/api/boarddata/${id}?export=t`);
    if(result && result.success){
        headline.value = result.data.headline;
        subheadline.value = result.data.subheadline;
        adminMail.value = result.data.adminMail;
        url.value = configuration.baseURL + basePath + result.data.hashcode;
        data.value = result.data.dataSet;
    }
}

getBoardData();

const generateDate = computed(() => {
    let date = new Date();
    let month = date.getMonth()+1;
    let day = date.getDate();
    let hours = date.getHours();
    let minutes = date.getMinutes();
    return `${day>9?day:"0"+day}.${month>9?month:"0"+month}.${date.getFullYear()} ${hours>9?hours:"0"+hours}:${minutes>9?minutes:"0"+minutes}`
});

const getBlockHeight = computed(() => {
    let calcHeight = 0;
    switch(pageOpts.size){
        case "A0":
            if(pageOpts.layout === "landscape"){
                calcHeight = 11 * 82
            }
            else {
                calcHeight = 7 * 116
            }
            break;
        case "A1":
            if(pageOpts.layout === "landscape"){
                calcHeight = 7 * 58
            }
            else {
                calcHeight = 5 * 82
            }
            break;
        case "A2":
            if(pageOpts.layout === "landscape"){
                calcHeight = 5 * 40
            }
            else {
                calcHeight = 3 * 58
            }
            break;
        case "A3":
            if(pageOpts.layout === "landscape"){
                calcHeight = 3 * 28
            }
            else {
                calcHeight = 2 * 40
            }
            break;
        case "A4":
            if(pageOpts.layout === "landscape"){
                calcHeight = 2 * 20
            }
            else {
                calcHeight = 1 * 28
            }
            break;
    }   
    return {"height":calcHeight+"cm"};
});

const removeColors = (text:string)=>{
    if(text){
        return text.replace(/<mark >/g,'<span ').replace(/<\/mark >/g,'</span>').replace(/(style=".+?")/gm,'');
    }else{
        return text;
    }
};

</script>
<template>
    <div id="export" class="h-full text-black">
        <div class="flex flex-row justify-between">
                <a class="h-[1.5cm] w-[1.5cm]" :href="basePath+'/'">
                    <img :src="basePath+'images/logo.png'" class="h-[1.5cm] w-[1.5cm]">
                </a>
            <p class="h-[1.5cm] leading-[1.5cm]">{{url}}</p>
        </div>    
        <div class="mt-[1.5cm]">
            <p>{{adminMail}}</p>
            <p class="text-2xl">{{headline}}</p>
            <p class="text-lg">{{subheadline}}</p>
            <p class="text-gray-500">{{generateDate}}</p>
        </div>    
       <div style="column-width:9cm;column-fill: auto;">
            <div v-for="element,index in data">
                <div :key="'s_'+index" v-if="element.id.includes('olumn')">
                    <h4 class="text-2xl export-column-header" v-html="removeColors(element.title)"></h4>
                    <div class="flex flex-col">
                        <div class="border border-black rounded-md mb-2" :key="postIndex" v-for="post,postIndex in element.posts">
                            <Post :post="post" :comments="pageOpts.comments"/>
                        </div>
                    </div>                   
                    <hr style="border-color:black">
                </div>
                <div :key="'f_'+index" v-else>
                    <Post class="border border-black rounded-md mb-2" :post="element" :comments="pageOpts.comments" />
                </div>
            </div>
            <div class="empty-column block" :style="[getBlockHeight]"></div>
        </div>
    </div>
</template>